/******************************************************************************
;  *       @型号                 : MC51F003A4
;  *       @创建日期             : 2023.02.01
;  *       @公司/作者            : SINOMCU.COM-AE
;  *       @晟矽微官网           : http://www.sinomcu.com/
;  *       @版权                 : 晟矽微电 版权所有.
;  *----------------------摘要描述---------------------------------
;  *    
******************************************************************************/

// <<< Use Configuration Wizard in Context Menu >>>
#ifndef __USER_CONFIG_H
#define __USER_CONFIG_H

#define FSYS_CLOCK      8000000
#define TIM_TICK_1MS    1000

// <c1> USE MCU HW MUL/DIV
// <i> Enable MCU hardware multipliction,division
#define EN_HW_MUL_DIV       1        // 1:Retargets printf to USART,0 or not define:printf null out
// </c>

// <o> MUL or DIV first variable
// <i> uint16_t,less than 65536
#define MUL_DIV_VAR_A       5000

// <o> MUL or DIV second variable
// <i> uint8_t,less than 256
#define MUL_DIV_VAR_B       102

// <c1> Printf to USART
// <i> Retargets printf to USART
#define EN_PRINT_UART        1         // 1:Retargets printf to USART,0 or not define:printf null out

// </c>
// <o> Baud Rate
// <i> select uart baud rate
// <0=>    2400
// <1=>    4800
// <2=>    9600
#define UART_BAUD_RATE  2        

#if (UART_BAUD_RATE == 2) 
#define BAUD_RATE   9600 
#elif (UART_BAUD_RATE == 1) 
#define BAUD_RATE   4800  
#else
#define BAUD_RATE   2400 
#endif

#endif /* __USER_CONFIG_H */
// <<< end of configuration section >>>
/******************************** END OF FILE *********************************/
