/******************************************************************************
;  *       @ͺ                 : MC51F003A4
;  *       @             : 2023.02.01
;  *       @˾/            : SINOMCU.COM-AE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : ΢ Ȩ.
;  *----------------------ժҪ---------------------------------
;  * Cacl_16mul8() 16bit*8bit,ʹMCUӲ.
;  * Cacl_16div8() 16bit/8bit,ʹMCUӲ.
;  *               ʹȫֱ(ٺ÷ֵֽλ).
******************************************************************************/

#include "user_config.h"
#include "GPIO.h"       /*ļѰ"MC51F003A4_COMMON.h"*/

/**
  * @brief  calculation 16bit multiplied 8bit
  * @param  
  *     uint16_t mulA:multiplicand
  *     uint8_t mulB:multiplier
  * @retval uint32_t:multiplied result
  */ 
uint32_t Cacl_16mul8(uint16_t mulA,uint8_t mulB) {
#if(defined(EN_HW_MUL_DIV) && EN_HW_MUL_DIV )
#else
  uint32_t Cacl_result=0;
#endif
  LED1_ON();            /*GPIO output high for test calculation time*/
#if(defined(EN_HW_MUL_DIV) && EN_HW_MUL_DIV )   
  AUXC = mulA>>8;       /*multiplicand high 8bit*/
  A = mulA;             /*multiplicand low 8bit*/
  B = mulB;             /*multiplier*/
#pragma ASM  
  MUL AB                
  MOV R7,A              /*return value low 8bit*/
  MOV R6,B              /*return value middle 8bit*/
  MOV R5,AUXC           /*return value high 8bit*/
  MOV R4,#0
#pragma ENDASM
  LED1_OFF();
#else
  Cacl_result =(uint32_t)mulA * mulB;
  LED1_OFF();  
  return Cacl_result;    
#endif
}

/*global division remainder*/
uint8_t g_div_remainder=0;

/**
  * @brief  calculation 16bit division 8bit
  * @param  
  *     uint16_t divA:dividend
  *     uint8_t divB:divisor
  * @retval uint6_t:division result
  * @note
  *     g_div_remainder(global variable) will be change by this function 
  */ 
uint16_t Cacl_16div8(uint16_t divA,uint8_t divB) {
#if(defined(EN_HW_MUL_DIV) && EN_HW_MUL_DIV )
#else
  uint16_t Cacl_result=0;
#endif
  LED1_ON();            /*GPIO output high for test calculation time*/
#if(defined(EN_HW_MUL_DIV) && EN_HW_MUL_DIV )   
  AUXC =divA>>8;        /*dividend high 8bit*/
  A = divA;             /*dividend low 8bit*/
  B = divB;             /*divisor*/
#pragma ASM  
  DIV AB
  MOV R7,A              /*return value low 8bit*/
  MOV R6,AUXC           /*return value high 8bit*/
#pragma ENDASM
  g_div_remainder =B;   /*division remainder*/
  LED1_OFF();
#else
  Cacl_result = divA / divB;
  LED1_OFF();
  return Cacl_result;  
#endif
}
/******************************** END OF FILE *********************************/